
import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 * file filter
 * 
 * @author chris
 *  
 */
public class EyeTrackFileFilter extends FileFilter {

	/** the extension we are interested in */
	private String extension;

	/** the description for this filter */
	private String description;

	/**
	 * default constructor
	 * 
	 * @param extension -
	 *            the extension to filter for
	 * @param description -
	 *            the description for this filter type
	 */
	public EyeTrackFileFilter(String extension, String description) {
		this.extension = extension;
		this.description = description;
	}

	/**
	 * @param file
	 *            the file to check
	 */
	public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}

		String extension = getExtension(f);
		if (extension != null) {
			if (extension.equals(this.extension))
				return true;
		} else {
			return false;
		}

		return false;
	}

	/**
	 * @return the description of the extension
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * 
	 * @param f -
	 *            some file
	 * @return the extension
	 */
	private static String getExtension(File f) {
		String ext = null;
		String s = f.getName();
		int i = s.lastIndexOf('.');

		if (i > 0 && i < s.length() - 1) {
			ext = s.substring(i + 1).toLowerCase();
		}
		return ext;
	}
}