/*
 * Created on Jul 17, 2004
 * PupilSessionData.java
 * 
 * Project: eyetrack_cvs
 */
package pupil;

import java.io.File;
import java.io.Serializable;
import java.util.Vector;

/**
 * @author chris
 *  
 */
public class PupilSessionData implements Serializable {

	/** The file the pupil data was read from */
	private File pupilFile;

	/** the file the task model data was read from */
	private File taskFile;

	/** the file the video data was read from */
	private File videoFile;

	/** the video offset* */
	private long videoOffset;

	/** the pupil Data */
	private Vector pupilData;

	/** the pupil baseline */
	private float baseLine;

	/** the max pcps */
	private float maxAbsPCPS;

	/** the min pcps* */
	private float minPCPS;

	/** the max pcps* */
	private float maxPCPS;

	/** the eye used for the pupilData */
	private int eye;

	/** the views... */
	private Vector views;

	/** the total number of view ever created */
	private int historicViewCount;

	/** the task model */
	private Vector taskModel;

	/** the trial data */
	private long[][] trialData;

	/** the pupil mask value */
	private float pupilMask;

	/**
	 * @return Returns the pupilMask.
	 */
	protected float getPupilMask() {
		return pupilMask;
	}

	/**
	 * @param pupilMask
	 *            The pupilMask to set.
	 */
	protected void setPupilMask(float pupilMask) {
		this.pupilMask = pupilMask;
	}

	/**
	 * default constructor
	 *  
	 */
	protected PupilSessionData() {
		pupilFile = null;
		taskFile = null;

		pupilData = null;
		eye = ReadPupil.LEFT;
		views = new Vector();
		historicViewCount = 0;
	}

	/**
	 * @return Returns the pupilData.
	 */
	protected Vector getPupilData() {
		return pupilData;
	}

	/**
	 * @param pupilData
	 *            The pupilData to set.
	 */
	protected void setPupilData(Vector pupilData) {
		this.pupilData = pupilData;
	}

	/**
	 * @return Returns the pupilFile.
	 */
	protected File getPupilFile() {
		return pupilFile;
	}

	/**
	 * @param pupilFile
	 *            The pupilFile to set.
	 */
	protected void setPupilFile(File pupilFile) {
		this.pupilFile = pupilFile;
	}

	/**
	 * @return Returns the eye.
	 */
	protected int getEye() {
		return eye;
	}

	/**
	 * @param eye
	 *            The eye to set.
	 */
	protected void setEye(int eye) {
		this.eye = eye;
	}

	/**
	 * @return Returns the perspectives.
	 */
	protected Vector getViews() {
		return views;
	}

	/**
	 * @param perspectives
	 *            The perspectives to set.
	 */
	protected void setViews(Vector views) {
		this.views = views;
	}

	/**
	 * @return Returns the historicPerspectiveCount.
	 */
	protected int getHistoricViewCount() {
		return historicViewCount;
	}

	/**
	 * @param historicPerspectiveCount
	 *            The historicPerspectiveCount to set.
	 */
	protected void incHistoricViewCount() {
		this.historicViewCount++;
	}

	/**
	 * @return Returns the baseLine.
	 */
	protected float getBaseLine() {
		return baseLine;
	}

	/**
	 * @param baseLine
	 *            The baseLine to set.
	 */
	protected void setBaseLine(float baseLine) {
		this.baseLine = baseLine;
	}

	/**
	 * @return Returns the maxAbsPCPS.
	 */
	protected float getMaxAbsPCPS() {
		return maxAbsPCPS;
	}

	/**
	 * @param maxAbsPCPS
	 *            The maxAbsPCPS to set.
	 */
	protected void setMaxAbsPCPS(float maxAbsPCPS) {
		this.maxAbsPCPS = maxAbsPCPS;
	}

	/**
	 * @return Returns the taskFile.
	 */
	protected File getTaskFile() {
		return taskFile;
	}

	/**
	 * @param taskFile
	 *            The taskFile to set.
	 */
	protected void setTaskFile(File taskFile) {
		this.taskFile = taskFile;
	}

	/**
	 * @return Returns the taskModel.
	 */
	protected Vector getTaskModel() {
		return taskModel;
	}

	/**
	 * @param taskModel
	 *            The taskModel to set.
	 */
	protected void setTaskModel(Vector taskModel) {
		this.taskModel = taskModel;
	}

	/**
	 * @return Returns the trialData.
	 */
	protected long[][] getTrialData() {
		return trialData;
	}

	/**
	 * @param trialData
	 *            The trialData to set.
	 */
	protected void setTrialData(long[][] trialData) {
		this.trialData = trialData;
	}

	/**
	 * @return Returns the maxPCPS.
	 */
	protected float getMaxPCPS() {
		return maxPCPS;
	}

	/**
	 * @param maxPCPS
	 *            The maxPCPS to set.
	 */
	protected void setMaxPCPS(float maxPCPS) {
		this.maxPCPS = maxPCPS;
	}

	/**
	 * @return Returns the minPCPS.
	 */
	protected float getMinPCPS() {
		return minPCPS;
	}

	/**
	 * @param minPCPS
	 *            The minPCPS to set.
	 */
	protected void setMinPCPS(float minPCPS) {
		this.minPCPS = minPCPS;
	}

	/**
	 * @return Returns the videoFile.
	 */
	protected File getVideoFile() {
		return videoFile;
	}

	/**
	 * @param videoFile
	 *            The videoFile to set.
	 */
	protected void setVideoFile(File videoFile) {
		this.videoFile = videoFile;
	}

	/**
	 * @return Returns the videoOffset.
	 */
	protected long getVideoOffset() {
		return videoOffset;
	}

	/**
	 * @param videoOffset
	 *            The videoOffset to set.
	 */
	protected void setVideoOffset(long videoOffset) {
		this.videoOffset = videoOffset;
	}
}