/*
 * Created on Jul 18, 2004
 * PupilViewData.java
 * 
 * Project: eyetrack_cvs
 */
package pupil;

import java.awt.Color;
import java.util.Vector;

/**
 * @author chris
 *  
 */
public class PupilViewData {

	/** the pupil data* */
	private Vector pupilData;

	/** the baseline* */
	private float baseline;

	/** the min PCPS* */
	private float minPCPS;

	/** the max PCPS* */
	private float maxPCPS;

	/** the task block data* */
	private Vector taskBlocks;

	/** the task block level colors* */
	private Color[] taskLevelColors = null;

	/**
	 * default constructor
	 *  
	 */
	protected PupilViewData() {
		pupilData = null;
	}

	/**
	 * @return Returns the pupilData.
	 */
	protected Vector getPupilData() {
		return pupilData;
	}

	/**
	 * @param pupilData
	 *            The pupilData to set.
	 */
	protected void setPupilData(Vector pupilData) {
		this.pupilData = pupilData;
	}

	/**
	 * method sets the min and max times of the context for this view
	 * 
	 * @param min
	 * @param max
	 */

	/**
	 * @return Returns the taskBlocks.
	 */
	protected Vector getTaskBlocks() {
		return taskBlocks;
	}

	/**
	 * @param taskBlocks
	 *            The taskBlocks to set.
	 */
	protected void setTaskBlocks(Vector taskBlocks) {
		this.taskBlocks = taskBlocks;
	}

	/**
	 * @return Returns the taskLevelColors.
	 */
	protected Color[] getTaskLevelColors() {
		return taskLevelColors;
	}

	/**
	 * @param taskLevelColors
	 *            The taskLevelColors to set.
	 */
	protected void setTaskLevelColors(Color[] taskLevelColors) {
		this.taskLevelColors = taskLevelColors;
	}

	/**
	 * @return Returns the baseline.
	 */
	protected float getBaseline() {
		return baseline;
	}

	/**
	 * @param baseline
	 *            The baseline to set.
	 */
	protected void setBaseline(float baseline) {
		this.baseline = baseline;
	}

	/**
	 * @return Returns the maxPCPS.
	 */
	protected float getMaxPCPS() {
		return maxPCPS;
	}

	/**
	 * @return Returns the minPCPS.
	 */
	protected float getMinPCPS() {
		return minPCPS;
	}

	/**
	 * method sets the min/max pcps
	 * 
	 * @param minPCPS
	 *            minPCPS to set
	 * @param maxPCPS
	 *            maxPCPS to set
	 */
	protected void setExtremePCPS(float minPCPS, float maxPCPS) {
		this.minPCPS = minPCPS;
		this.maxPCPS = maxPCPS;
	}
}