/*
 * Created on Sep 3, 2004
 * SmoothingDialog.java
 * 
 * Project: eyetrack_cvs
 */

package pupil;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;



/**
 * @author BPB dialog box for getting the baseline pupil size or the time
 *         bounds for where the baseline was calculated.
 */
public class SmoothingDialog extends JDialog {

	/** text field for the value */
	private JTextField smoothingField;

	/** OK button */
	private JButton okBu;

	/** CANCEL button */
	private JButton cancelBu;

	/** min time set by the user */
	private int smoothingValue = 0;




	public SmoothingDialog(JFrame owner, int v) {
		super(owner, "Set Filter Window Size");

		//initialize the other buttons
		okBu = new JButton("OK");
		okBu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				//verify that the entered text is valid.
				smoothingValue = 0;
				try {
					smoothingValue = Integer.parseInt(smoothingField.getText());
				} catch (Exception xcptn) {
				}
				SmoothingDialog.this.setVisible(false);
			}

		});

		cancelBu = new JButton("Cancel");
		cancelBu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				SmoothingDialog.this.setVisible(false);
			}

		});

		smoothingField = new JTextField(Integer.toString(v), 3);

		// just a friendly label.
		JLabel label = new JLabel("Enter filter window  ");

		//the button panel holds the ok and cancel buttons
		JPanel buttonPanel = new JPanel();
		buttonPanel.setBorder(BorderFactory.createEmptyBorder(7, 7, 7, 7));
		buttonPanel.add(okBu);
		buttonPanel.add(cancelBu);

		JPanel j = new JPanel();
		j.setBorder((Border) BorderFactory.createEmptyBorder(15, 15, 15, 15));
		setContentPane(j);

		getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.gridy = 0;
		c.anchor = GridBagConstraints.WEST;
		getContentPane().add(label, c);

		c.gridx = 1;
		getContentPane().add(smoothingField, c);

		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 2;
		getContentPane().add(buttonPanel, c);

		pack();
	}


	/**
	 * @return the user entered baseline value
	 */
	public int getSmoothingValue() {
		return smoothingValue;
	}
}