/*
 * Created on Jun 30, 2004
 *
 */
package pupil;

/**
 * @author chris
 * 
 * a start event packet
 */
public class StartPacket extends DataPacket {

	/** the trial to which this packet belongs */
	private int trial;

	/**
	 * @param timeStamp -
	 *            timestamp for this event
	 * @param trial -
	 *            trial this event starts
	 */
	public StartPacket(long timeStamp, int trial) {
		super(timeStamp);
		this.trial = trial;
	}

	/**
	 * @return Returns the trial.
	 */
	public int getTrial() {
		return trial;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Start of trial " + getTrial() + ": " + getTimeStamp();
	}
}