/*
 * Created on Jul 22, 2004
 * TaskBlock.java
 * 
 * Project: eyetrack_cvs
 */
package task;

import java.io.Serializable;
import java.util.Vector;

/**
 * @author chris
 *  
 */
public class TaskBlock implements Serializable {

	/** the name for this task block* */
	private String name;

	/** the starting, ending time for this task block* */
	private long startTime, endTime;

	/** the children of this task block */
	private Vector taskChildren;

	/** the level of this task block */
	private int level;

	/** flag indicating weather this flag is focus selected* */
	private boolean highlightFocus;

	/** flag indicating weather this flag is selected* */
	private boolean highlightSelected;

	/**
	 * default constructor
	 *  
	 */
	public TaskBlock() {
		name = null;
		startTime = -1;
		endTime = -1;
		level = -1;
		taskChildren = new Vector();
		highlightFocus = false;
	}

	/**
	 * @return Returns the level.
	 */
	public int getLevel() {
		return level;
	}

	/**
	 * @param level
	 *            The level to set.
	 */
	public void setLevel(int level) {
		this.level = level;
	}

	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return Returns the taskChildren.
	 */
	public Vector getTaskChildren() {
		return taskChildren;
	}

	/**
	 * @param taskChildren
	 *            The taskChildren to set.
	 */
	public void setTaskChildren(Vector taskChildren) {
		this.taskChildren = taskChildren;
	}

	/**
	 * @return Returns the endTime.
	 */
	public long getEndTime() {
		return endTime;
	}

	/**
	 * @return Returns the startTime.
	 */
	public long getStartTime() {
		return startTime;
	}

	/**
	 * method sets the start and end times of this task block
	 * 
	 * @param start
	 * @param end
	 */
	public void setTimes(long start, long end) {
		this.startTime = start;
		this.endTime = end;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		if (name != null)
			return getLevel() + ") " + name + ": " + startTime + ", " + endTime;
		else
			return "no name";
	}

	/**
	 * @return Returns the focused.
	 */
	protected boolean isHighlightFocused() {
		return highlightFocus;
	}

	/**
	 * @param focused
	 *            The focused to set.
	 */
	protected void setHighlightFocus(boolean focused) {
		this.highlightFocus = focused;
	}

	/**
	 * @return Returns the highlightSelected.
	 */
	protected boolean isHighlightSelected() {
		return highlightSelected;
	}

	/**
	 * @param highlightSelected
	 *            The highlightSelected to set.
	 */
	protected void setHighlightSelected(boolean highlightSelected) {
		this.highlightSelected = highlightSelected;
	}

	/**
	 * @param endTime
	 *            The endTime to set.
	 */
	public void setEndTime(long endTime) {
		this.endTime = endTime;
	}

	/**
	 * @param startTime
	 *            The startTime to set.
	 */
	public void setStartTime(long startTime) {
		this.startTime = startTime;
	}
}