/*
 * Created on Oct 9, 2004
 * MYMovie.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * @author chris interface to actual quicktime.std.movies.Movie class
 */
public class MYMovie {

	/** the actual movie object */
	private Object movie;

	/**
	 * private wrapper constructor sets the wrapped movie object
	 * 
	 * @param object
	 */
	private MYMovie(Object movie) {
		this.movie = movie;
	}

	/**
	 * method returns the actual Movie object
	 * 
	 * @return
	 */
	protected Object getMovie() {
		return movie;
	}

	/**
	 * same as getRate of actual quicktime.std.movies.Movie class
	 * 
	 * @return @throws
	 *         IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 */
	public float getRate() throws IllegalArgumentException, SecurityException,
			IllegalAccessException, InvocationTargetException,
			NoSuchMethodException {
		return ((Float) movie.getClass().getMethod("getRate", null).invoke(
				movie, null)).floatValue();
	}

	/**
	 * same as setRate of actual quicktime.std.movies.Movie class
	 * 
	 * @param rate
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 */
	public void setRate(float rate) throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		movie.getClass().getMethod("setRate", new Class[] { float.class })
				.invoke(movie, new Object[] { new Float(rate) });
	}

	/**
	 * same as setTimeValue of actual quicktime.std.movies.Movie class
	 * 
	 * @param time
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 */
	public void setTimeValue(int time) throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		movie.getClass().getMethod("setTimeValue", new Class[] { int.class })
				.invoke(movie, new Object[] { new Integer(time) });
	}

	/**
	 * same as getTime of actual quicktime.std.movies.Movie class
	 * 
	 * @return @throws
	 *         IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 */
	public int getTime() throws IllegalArgumentException, SecurityException,
			IllegalAccessException, InvocationTargetException,
			NoSuchMethodException {
		return ((Integer) movie.getClass().getMethod("getTime", null).invoke(
				movie, null)).intValue();
	}

	/**
	 * same as removeDrawingCompleteProc of actual quicktime.std.movies.Movie
	 * class
	 * 
	 * @throws NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public void removeDrawingCompleteProc() throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		movie.getClass().getMethod("removeDrawingCompleteProc", null).invoke(
				movie, null);
	}

	/**
	 * same as fromFile of actual quicktime.std.movies.Movie class
	 * 
	 * @param movieFile
	 * @return @throws
	 *         InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws IllegalArgumentException
	 * @throws ClassNotFoundException
	 * @throws NoSuchMethodException
	 * @throws SecurityException
	 */
	public static MYMovie fromFile(MYOpenMovieFile movieFile)
			throws IllegalArgumentException, IllegalAccessException,
			InvocationTargetException, SecurityException,
			NoSuchMethodException, ClassNotFoundException {
		Class movieClass = ClassLoader.getSystemClassLoader().loadClass(
				"quicktime.std.movies.Movie");
		Method fromFileMethod = movieClass.getMethod("fromFile",
				new Class[] { ClassLoader.getSystemClassLoader().loadClass(
						"quicktime.io.OpenMovieFile") });
		//invoke this method
		return new MYMovie(fromFileMethod.invoke(null, new Object[] { movieFile
				.toOpenMovieFile() }));
	}

	/**
	 * same as getTimeBase of actual quicktime.std.movies.Movie class
	 * 
	 * @return @throws
	 *         NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public MYMovieController getTimeBase() throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		return new MYMovieController(movie.getClass().getMethod("getTimeBase",
				null).invoke(movie, null));
	}

	/**
	 * same as getDuration of actual quicktime.std.movies.Movie class
	 * 
	 * @return @throws
	 *         NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public int getDuration() throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		return ((Integer) movie.getClass().getMethod("getDuration", null)
				.invoke(movie, null)).intValue();
	}

	/**
	 * same as getTimeScale of actual quicktime.std.movies.Movie class
	 * 
	 * @return @throws
	 *         NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public int getTimeScale() throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		return ((Integer) movie.getClass().getMethod("getTimeScale", null)
				.invoke(movie, null)).intValue();
	}

	/**
	 * @param i
	 * @param desktop
	 * @throws ClassNotFoundException
	 * @throws NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public void setDrawingCompleteProc(int flags, MYMovieDrawingComplete proc)
			throws IllegalArgumentException, SecurityException,
			IllegalAccessException, InvocationTargetException,
			NoSuchMethodException, ClassNotFoundException {
		movie.getClass().getMethod(
				"setDrawingCompleteProc",
				new Class[] {
						int.class,
						ClassLoader.getSystemClassLoader().loadClass(
								"quicktime.std.movies.MovieDrawingComplete") })
				.invoke(movie, new Object[] { new Integer(flags), proc });
	}
}