/*
 * Created on Oct 9, 2004
 * MYQTFactory.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.awt.Component;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * @author chris interface for quicktime.app.view.QTFactory class
 */
public class MYQTFactory {

	/**
	 * same as makeQTComponent of quicktime.app.view.QTFactory class
	 * 
	 * @param movie
	 * @return @throws
	 *         ClassNotFoundException
	 * @throws NoSuchMethodException
	 * @throws SecurityException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws IllegalArgumentException
	 */
	public static Component makeQTComponent(MYMovie movie)
			throws SecurityException, NoSuchMethodException,
			ClassNotFoundException, IllegalArgumentException,
			IllegalAccessException, InvocationTargetException {
		Class qtFactoryClass = ClassLoader.getSystemClassLoader().loadClass(
				"quicktime.app.view.QTFactory");
		Method makeQTComponentMethod = qtFactoryClass.getMethod(
				"makeQTComponent", new Class[] { ClassLoader
						.getSystemClassLoader().loadClass(
								"quicktime.std.movies.Movie") });
		//invoke this method
		if (movie != null)
			return (Component) makeQTComponentMethod.invoke(null,
					new Object[] { movie.getMovie() });
		else
			return (Component) makeQTComponentMethod.invoke(null,
					new Object[] { null });
	}

}