/*
 * Created on Oct 9, 2004
 * MYQTSession.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * @author chris
 * 
 * class interface to actual quicktime.QTSession class
 */
public class MYQTSession {

	/**
	 * same as open method of actual quicktime.QTSession class. throws exception
	 * if class cannot be loaded.
	 * 
	 * @throws ClassNotFoundException
	 * @throws SecurityException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 */
	public static void open() throws ClassNotFoundException, SecurityException,
			NoSuchMethodException, IllegalArgumentException,
			IllegalAccessException, InvocationTargetException {
		Class qtSessionClass;
		try {
			qtSessionClass = ClassLoader.getSystemClassLoader().loadClass(
					"quicktime.QTSession");
		} catch (Exception e) {
			System.out.println("no class qtsession!");
			e.printStackTrace();
			return;
		}
		Method openMethod;
		try {
			openMethod = qtSessionClass.getMethod("open", null);
		} catch (Exception e) {
			System.out.println("no method!");
			e.printStackTrace();
			return;
		}
		//invoke this method
		try {
			openMethod.invoke(null, null);
		} catch (Exception e) {
			System.out.println("no invoke!");
			e.printStackTrace();
			return;
		}
	}

	/**
	 * same as close method of actual quicktime.QTSession class. throws
	 * exception if class cannot be loaded.
	 * 
	 * @throws ClassNotFoundException
	 * @throws SecurityException
	 * @throws NoSuchMethodException
	 * @throws IllegalArgumentException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 */
	public static void close() throws ClassNotFoundException,
			SecurityException, NoSuchMethodException, IllegalArgumentException,
			IllegalAccessException, InvocationTargetException {
		Class qtSessionClass = ClassLoader.getSystemClassLoader().loadClass(
				"quicktime.QTSession");
		Method openMethod = qtSessionClass.getMethod("close", null);
		//invoke this method
		openMethod.invoke(null, null);
	}
}