/*
 * Created on Sep 2, 2004
 * NotesView.java
 * 
 * Project: eyetrack_cvs
 */
package view;

import java.awt.*;
import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.*;

/**
 * @author chris
 *  
 */
public class NotesView extends JDialog implements View {
	/** comments textarea */
	private JTextArea comments;

	/** scroll pane for holding comments */
	private JScrollPane notesScrollpane;

	/**
	 * default constructor
	 * 
	 * @param owner
	 *            the parent frame
	 * @param name
	 *            title bar name
	 */
	public NotesView(JFrame owner, String name) {
		super(owner, name);
		comments = new JTextArea(8, 30);
		comments.setLineWrap(true);
		comments.setWrapStyleWord(true);
		comments.setFont(new Font(comments.getFont().getFamily(), Font.BOLD, comments.getFont().getSize() + 2));
		comments.setBorder(BorderFactory.createEmptyBorder(5,10,5,10));


		notesScrollpane = new JScrollPane(comments);
		notesScrollpane
				.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);


		this.getContentPane().setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 0.0;
		c.weighty = 0.0;
		this.getContentPane().add(new JLabel("Comments/Discoveries:"), c);

		c.gridy = 1;
		c.weightx = 1.0;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.BOTH;
		this.getContentPane().add(notesScrollpane, c);

		pack();
	}

	/**
	 * method returns the notes currently entered in the text box
	 * 
	 * @return - the notes
	 */
	public String getNotes() {
		return comments.getText();
	}

	/**
	 * method sets the notes entered in the text box
	 * 
	 * @param notes -
	 *            the notes to set
	 */
	public void setNotes(String notes) {
		comments.setText(notes);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#setSelection(long, long)
	 */
	public void setSelection(long minTime, long maxTime) {
		// what could go here?

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#setLocal(long, long)
	 */
	public void setLocal(long minTime, long maxTime) {
		// what could go here?

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#setGlobal(long, long)
	 */
	public void setGlobal(long inTime, long maxTime) {
		// what could go here?

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#purge()
	 */
	public void purge() {
		setNotes(null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#previewSelection(long, long)
	 */
	public void previewSelection(long minTime, long maxTime) {
		// ...

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.View#previewLocal(long, long)
	 */
	public void previewLocal(long minTime, long maxTime) {
		// ...
	}
}