/*
 * Created on Oct 9, 2004
 * MYMovieController.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.lang.reflect.InvocationTargetException;

/**
 * @author chris interface for quicktime.std.movies.MovieController class
 */
public class MYMovieController {
	/** actual movieController object */
	private Object movieController;

	/**
	 * constructor sets the actual MovieController object
	 * 
	 * @param movieController
	 */
	protected MYMovieController(Object movieController) {
		this.movieController = movieController;
	}

	/**
	 * same as actual quicktime.std.movies.MovieController class
	 * 
	 * @param loopTimeBase
	 * @throws NoSuchMethodException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws SecurityException
	 * @throws IllegalArgumentException
	 */
	public void setFlags(int flags) throws IllegalArgumentException,
			SecurityException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		movieController.getClass().getMethod("setFlags",
				new Class[] { int.class }).invoke(movieController,
				new Object[] { new Integer(flags) });
	}

	/**
	 * same as setStopTime in actual quicktime.std.movies.MovieController class
	 * 
	 * @param record
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 * @throws ClassNotFoundException
	 */
	public void setStopTime(MYTimeRecord record)
			throws IllegalArgumentException, SecurityException,
			IllegalAccessException, InvocationTargetException,
			NoSuchMethodException, ClassNotFoundException {
		if (record != null)
			movieController.getClass().getMethod("setStopTime",
					new Class[] { record.getTimeRecord().getClass() }).invoke(
					movieController, new Object[] { record.getTimeRecord() });
		else
			movieController.getClass().getMethod(
					"setStopTime",
					new Class[] { ClassLoader.getSystemClassLoader().loadClass(
							"quicktime.std.clocks.TimeRecord") }).invoke(
					movieController, new Object[] { null });
	}

	/**
	 * same as setStartTime in actual quicktime.std.movies.MovieController class
	 * 
	 * @param record
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 * @throws ClassNotFoundException
	 */
	public void setStartTime(MYTimeRecord record)
			throws IllegalArgumentException, SecurityException,
			IllegalAccessException, InvocationTargetException,
			NoSuchMethodException, ClassNotFoundException {
		if (record != null)
			movieController.getClass().getMethod(
					"setStartTime",
					new Class[] { ClassLoader.getSystemClassLoader().loadClass(
							"quicktime.std.clocks.TimeRecord") }).invoke(
					movieController, new Object[] { record.getTimeRecord() });
		else
			movieController.getClass().getMethod(
					"setStartTime",
					new Class[] { ClassLoader.getSystemClassLoader().loadClass(
							"quicktime.std.clocks.TimeRecord") }).invoke(
					movieController, new Object[] { null });
	}

}