/*
 * Created on Oct 9, 2004
 * MYOpenMovieFile.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * @author chris interface for actual quicktime.io.OpenMovieFile class
 */
public class MYOpenMovieFile {

	/** the actual openMovieFile object* */
	private Object openMovieFile;

	/**
	 * private constructor. takes as input an actual OpenMovieFile object
	 * 
	 * @param openMovieFile
	 */
	private MYOpenMovieFile(Object openMovieFile) {
		this.openMovieFile = openMovieFile;
	}

	/**
	 * same as asRead method of actual quicktime.io.OpenMovieFile class
	 * 
	 * @param file
	 * @return @throws
	 *         ClassNotFoundException
	 * @throws NoSuchMethodException
	 * @throws SecurityException
	 * @throws InvocationTargetException
	 * @throws IllegalAccessException
	 * @throws IllegalArgumentException
	 */
	public static MYOpenMovieFile asRead(MYQTFile file)
			throws SecurityException, NoSuchMethodException,
			ClassNotFoundException, IllegalArgumentException,
			IllegalAccessException, InvocationTargetException {
		Class openMovieFileClass = ClassLoader.getSystemClassLoader()
				.loadClass("quicktime.io.OpenMovieFile");
		Method asReadMethod = openMovieFileClass.getMethod("asRead",
				new Class[] { ClassLoader.getSystemClassLoader().loadClass(
						"quicktime.io.QTFile") });
		//invoke this method
		return new MYOpenMovieFile(asReadMethod.invoke(null,
				new Object[] { file.toQTFile() }));
	}

	/**
	 * method returns the actual openMovieFile
	 * 
	 * @return
	 */
	protected Object toOpenMovieFile() {
		return openMovieFile;
	}

}