/*
 * Created on Oct 9, 2004
 * MYTimeRecord.java
 * 
 * Project: eyetrack_cvs
 */
package video;

import java.lang.reflect.InvocationTargetException;

/**
 * @author chris interface to actual quicktime.std.clocks.TimeRecord class
 */
public class MYTimeRecord {

	/** the actual time record object* */
	private Object timeRecord = null;

	/**
	 * wrapper constructor of actual quicktime.std.clocks.TimeRecord class
	 * 
	 * @param scale
	 * @param time
	 * 
	 * @throws ClassNotFoundException
	 * @throws IllegalArgumentException
	 * @throws SecurityException
	 * @throws InstantiationException
	 * @throws IllegalAccessException
	 * @throws InvocationTargetException
	 * @throws NoSuchMethodException
	 */
	public MYTimeRecord(int scale, long time) throws ClassNotFoundException,
			IllegalArgumentException, SecurityException,
			InstantiationException, IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {
		Class timeRecordClass = ClassLoader.getSystemClassLoader().loadClass(
				"quicktime.std.clocks.TimeRecord");
		Class[] tmp = { int.class, long.class };
		timeRecord = timeRecordClass.getConstructor(
				new Class[] { int.class, long.class }).newInstance(
				new Object[] { new Integer(scale), new Long(time) });
	}

	/**
	 * method returns the actual time record use by MYTimeRecord
	 * 
	 * @return
	 */
	protected Object getTimeRecord() {
		return timeRecord;
	}

}