package video;

/*
 * Created on Sep 30, 2004
 * VideoDialog.java
 * 
 * Project: eyetrack_cvs
 */

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.NumberFormat;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author chris
 *  
 */
public class VideoDialog extends JDialog {

	/** the offset text field* */
	private JFormattedTextField offsetField;

	/** the offset set by the user* */
	private long offset = -1;

	/** flag indicating whether the user gave data or not */
	private boolean haveData = false;

	/**
	 * default constructor
	 * 
	 * @param owner -
	 *            the parent frame
	 */
	public VideoDialog(JFrame owner) {
		super(owner, "Set Video Offset");

		//initialize the text field
		NumberFormat nf = NumberFormat.getNumberInstance();
		nf.setGroupingUsed(false);
		offsetField = new JFormattedTextField(nf);
		//offsetField.setValue(new Long(0));
		//offsetField.setMaximumSize(new
		// Dimension(offsetField.getPreferredSize().width*8,offsetField.getPreferredSize().height));
		//TODO: get rid of hard coded video value
		offsetField.setValue(new Long(1531934));
		offsetField.setMaximumSize(offsetField.getPreferredSize());

		//just a friendly label.
		JPanel labelPanel = new JPanel();
		labelPanel.setLayout(new BoxLayout(labelPanel, BoxLayout.LINE_AXIS));
		JLabel alabel = new JLabel(
				"<html>What is the \"Zero Time\" of the video relative to the<br> EyeTracker System Clock?  This is the timestamp<br> of the pupil data when the video begins.");
		labelPanel.add(alabel);
		labelPanel.add(Box.createHorizontalGlue());
		labelPanel.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

		//panel to hold the input box
		JPanel aPanel = new JPanel();
		aPanel.setLayout(new BoxLayout(aPanel, BoxLayout.LINE_AXIS));
		aPanel.add(new JLabel("Video Offset: "));
		aPanel.add(Box.createRigidArea(new Dimension(10, 0)));
		aPanel.add(offsetField);

		//set up the buttons and put them in a panel
		JButton okBu = new JButton("OK");
		okBu.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				//set offset. we have data. get out.
				offset = ((Number) offsetField.getValue()).longValue();
				haveData = true;
				setVisible(false);
			}

		});

		JButton cancelBu = new JButton("Cancel");
		cancelBu.addActionListener(new ActionListener() {
			//hide myself on pressing cancel
			public void actionPerformed(ActionEvent arg0) {
				setVisible(false);

			}
		});

		JPanel buttonPanel = new JPanel();
		buttonPanel.setBorder(BorderFactory.createEmptyBorder(7, 7, 7, 7));
		buttonPanel.add(okBu);
		buttonPanel.add(cancelBu);

		this.getContentPane().setLayout(
				new BoxLayout(this.getContentPane(), BoxLayout.PAGE_AXIS));
		this.getContentPane().add(labelPanel);
		this.getContentPane().add(Box.createRigidArea(new Dimension(0, 10)));
		this.getContentPane().add(aPanel);
		this.getContentPane().add(buttonPanel);

		this.pack();
	}

	/**
	 * @return true if data is entered, false if data not entered
	 */
	public boolean dataEntered() {
		return haveData;
	}

	/**
	 * 
	 * @return the offset as provided by the user
	 */
	public long getOffset() {
		return offset;
	}

}