/*
 * Created on Oct 31, 2004
 * ViewPanel.java
 * 
 * Project: eyetrack_cvs
 */
package view;

import java.util.Vector;

import javax.swing.JPanel;

import session.SessionHandler;

/**
 * @author chris
 *  
 */
public abstract class ViewPanel extends JPanel implements View {

	protected SessionHandler sessionHandler;

	private long minGlobal = -1;

	private long maxGlobal = -1;

	private long minLocal = -1;

	private long maxLocal = -1;

	private long minSelection = -1;

	private long maxSelection = -1;

	private String notes = null;

	private String globalMenuText;

	public ViewPanel(SessionHandler sessionHandler) {
		this.sessionHandler = sessionHandler;
	}

	/**
	 * get the notes for this view panel
	 * 
	 * @return
	 */
	public String getNotes() {
		return notes;
	}

	/**
	 * set the notes for this view panel
	 * 
	 * @param notes
	 */
	public void setNotes(String notes) {
		this.notes = notes;
	}

	public long getMinGlobal() {
		return minGlobal;
	}

	public long getMaxGlobal() {
		return maxGlobal;
	}

	public void setGlobal(long minTime, long maxTime) {
		minGlobal = minTime;
		maxGlobal = maxTime;
	}

	public long getMinLocal() {
		return minLocal;
	}

	public long getMaxLocal() {
		return maxLocal;
	}

	public void setLocal(long minTime, long maxTime) {
		minLocal = minTime;
		maxLocal = maxTime;
	}

	public long getMinSelection() {
		return minSelection;
	}

	public long getMaxSelection() {
		return maxSelection;
	}

	public void setSelection(long minTime, long maxTime) {
		minSelection = minTime;
		maxSelection = maxTime;
	}

	public String getGlobalMenuText() {
		return globalMenuText;
	}

	public void setGlobalMenuText(String globalMenuText) {
		this.globalMenuText = globalMenuText;
	}

	public abstract void importSettings(Vector settings);

	public abstract Vector exportSettings();

}