/*
 * Created on Oct 31, 2004
 * VisWindowDecorator.java
 * 
 * Project: eyetrack_cvs
 */
package view;

import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;

/**
 * @author chris
 *  
 */
public class VisWindowDecorator extends VisWindow {

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#previewLocalTimesByGlobal(long, long)
	 */
	public void previewLocalTimesByGlobal(long minTime, long maxTime) {
		theWindow.previewLocalTimesByGlobal(minTime, maxTime);
	}

	/** the viswindow to decorate* */
	protected VisWindow theWindow;

	/**
	 * 
	 * @param theWindow
	 *            the window to decorate
	 */
	public VisWindowDecorator(VisWindow theWindow) {
		this.theWindow = theWindow;
	}

	/**
	 * method returns the contained visWindow
	 * 
	 * @return
	 */
	public VisWindow getVisWindow() {
		return theWindow;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#drawLabels(java.awt.Graphics2D, java.awt.Font)
	 */
	public void drawLabels(Graphics2D g2, Font f) {
		theWindow.drawLabels(g2, f);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getToolTip(java.awt.event.MouseEvent)
	 */
	public String getToolTip(MouseEvent e) {
		return theWindow.getToolTip(e);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#previewGlobalTimes(long, long)
	 */
	public void previewGlobalTimes(long minTime, long maxTime) {
		theWindow.previewGlobalTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#previewLocalTimes(long, long)
	 */
	public void previewLocalTimesByLocal(long minTime, long maxTime) {
		theWindow.previewLocalTimesByLocal(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#previewSelectionTimes(long, long)
	 */
	public void previewSelectionTimes(long minTime, long maxTime) {
		theWindow.previewSelectionTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#setGlobalTimes(long, long)
	 */
	public void setGlobalTimes(long minTime, long maxTime) {
		theWindow.setGlobalTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#setLocalTimes(long, long)
	 */
	public void setLocalTimes(long minTime, long maxTime) {
		theWindow.setLocalTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#setSelectionTimes(long, long)
	 */
	public void setSelectionTimes(long minTime, long maxTime) {
		theWindow.setSelectionTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#setViewTimes(long, long)
	 */
	public void setViewTimes(long minTime, long maxTime) {
		theWindow.setViewTimes(minTime, maxTime);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getMinViewTime()
	 */
	public long getMinViewTime() {
		return theWindow.getMinViewTime();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getMaxViewTime()
	 */
	public long getMaxViewTime() {
		return theWindow.getMaxViewTime();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#setDrawRegion(java.awt.Rectangle)
	 */
	public void setDrawRegion(Rectangle drawRegion) {
		theWindow.setDrawRegion(drawRegion);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getDrawRegion()
	 */
	public Rectangle getDrawRegion() {
		return theWindow.getDrawRegion();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#drawWindow(java.awt.Graphics2D)
	 */
	public void drawWindow(Graphics2D g2) {
		theWindow.drawWindow(g2);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getTime(int)
	 */
	public double getTime(int x) {
		return theWindow.getTime(x);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see view.VisWindow#getXCoord(double)
	 */
	public int getXCoord(double time) {
		return theWindow.getXCoord(time);
	}

}